Index: branches/thasling/DistributedGA/DistributedGA.Core.Host/Program.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core.Host/Program.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core.Host/Program.cs	(revision 13553)
@@ -25,8 +25,8 @@
           var pop1 = CreatePopulation();
           Console.WriteLine("Publish population into network...");
-          h.PublishMigrationInfo(pop1);
+          h.PublishDataToNetwork(pop1);
           Console.WriteLine("Population published.");
           Console.WriteLine("Recieved populations:");
-          foreach (var item in h.GetMigrationInfo()) {
+          foreach (var item in h.GetDataFromNetwork()) {
             Console.WriteLine(string.Format("Population with Quality: {0:2} in Iteration {1}", item.Quality, item.IterationNumber));
           }
Index: branches/thasling/DistributedGA/DistributedGA.Core/Domain/MessageRecieveEventArgs.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Domain/MessageRecieveEventArgs.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Domain/MessageRecieveEventArgs.cs	(revision 13553)
@@ -1,15 +1,9 @@
 ﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
 
-namespace DistributedGA.Core.Domain
-{
-    public class MessageRecieveEventArgs : EventArgs
-    {
-        public int val;
-        public SolutionInfo[] Population { get; set; }
-        public PeerInfo Sender { get; set; }
-    }
+namespace DistributedGA.Core.Domain {
+  public class MessageRecieveEventArgs : EventArgs {
+    public int val;
+    public SolutionInfo[] data { get; set; }
+    public PeerInfo Sender { get; set; }
+  }
 }
Index: branches/thasling/DistributedGA/DistributedGA.Core/Implementation/MessageContractImpl.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Implementation/MessageContractImpl.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Implementation/MessageContractImpl.cs	(revision 13553)
@@ -7,6 +7,6 @@
   [ServiceBehavior(InstanceContextMode = InstanceContextMode.Single)]
   public class MessageContractImpl : IMessageContract {
-    public void SendPopulation(PeerInfo sender, SolutionInfo[] population) {
-      MessageRecieveEventArgs args = new MessageRecieveEventArgs() { Sender = sender, Population = population };
+    public void SendData(PeerInfo sender, SolutionInfo[] data) {
+      MessageRecieveEventArgs args = new MessageRecieveEventArgs() { Sender = sender, data = data };
 
       if (MessageRecieved != null) {
Index: branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Implementation/PeerNetworkMessageHandler.cs	(revision 13553)
@@ -43,5 +43,5 @@
         host = new WcfMessageService();
         ownInstance.Port = host.Init(ownInstance.IpAddress); //getting port, on which service is hostet
-        host.OnPopulationRecieved += new EventHandler<MessageRecieveEventArgs>(OnPopulationRecieved);
+        host.OnDataRecieved += new EventHandler<MessageRecieveEventArgs>(OnPopulationRecieved);
 
         peerListManager = new WcfPeerListManager();
@@ -65,14 +65,14 @@
     }
 
-    public void PublishMigrationInfo(SolutionInfo[] population) {
+    public void PublishDataToNetwork(SolutionInfo[] data) {
       try {
         foreach (PeerInfo peer in peerListManager.GetPeerList()) {
           //HACK: manipulate for monitoring in test
-          foreach (SolutionInfo si in population) {
+          foreach (SolutionInfo si in data) {
             si.IterationNumber = ownInstance.Port;
           }
           //maybe something will go wrong during network communication...
           try {
-            sender.SendPopulation(peer, population);
+            sender.SendData(peer, data);
           } catch (Exception ex) {
             AddError("PeerNetworkMessageHandler.PublishMigrationInfo(during sending to one peer!)", ex);
@@ -84,5 +84,5 @@
     }
 
-    public SolutionInfo[] GetMigrationInfo() {
+    public SolutionInfo[] GetDataFromNetwork() {
       try {
         List<SolutionInfo> res = new List<SolutionInfo>();
@@ -131,5 +131,5 @@
       if (e != null) {
         lock (activeQueueLocker) {
-          foreach (SolutionInfo si in e.Population) {
+          foreach (SolutionInfo si in e.data) {
             writeQueue.Enqueue(si);
           }
Index: branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageSender.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageSender.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageSender.cs	(revision 13553)
@@ -1,43 +1,34 @@
-﻿using DistributedGA.Core.Domain;
+﻿using System;
+using System.ServiceModel;
+using DistributedGA.Core.Domain;
 using DistributedGA.Core.Interface;
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.ServiceModel;
-using System.Text;
-using System.Threading.Tasks;
 
-namespace DistributedGA.Core.Implementation
-{
-    public class WcfMessageSender : IMessageSender
-    {
-        private PeerInfo myself;
+namespace DistributedGA.Core.Implementation {
+  public class WcfMessageSender : IMessageSender {
+    private PeerInfo myself;
 
-        public void Init(PeerInfo source)
-        {
-            myself = source;
-        }
+    public void Init(PeerInfo source) {
+      myself = source;
+    }
 
-        public void SendPopulation(PeerInfo destination, SolutionInfo[] population)
-        {
-            var client = CreateServerClient(destination.IpAddress, destination.Port);
-            client.SendPopulation(myself, population); //maybe timout exception...
-        }
+    public void SendData(PeerInfo destination, SolutionInfo[] data) {
+      var client = CreateServerClient(destination.IpAddress, destination.Port);
+      client.SendData(myself, data); //maybe timout exception...
+    }
 
-        private IMessageContract CreateServerClient(string ip, int port)
-        {
-            var serviceUrl = "DistributedGA.svc";
-            var baseUri = new Uri(string.Concat("http://", ip, ":", port, "/DistributedGA"));
-            var serviceUri = new Uri(baseUri, serviceUrl);
+    private IMessageContract CreateServerClient(string ip, int port) {
+      var serviceUrl = "DistributedGA.svc";
+      var baseUri = new Uri(string.Concat("http://", ip, ":", port, "/DistributedGA"));
+      var serviceUri = new Uri(baseUri, serviceUrl);
 
-            var binding = new BasicHttpBinding();
-            var endpoint = new EndpointAddress(serviceUri);
-            var myChannelFactory = new ChannelFactory<IMessageContract>(binding, endpoint);
+      var binding = new BasicHttpBinding();
+      var endpoint = new EndpointAddress(serviceUri);
+      var myChannelFactory = new ChannelFactory<IMessageContract>(binding, endpoint);
 
-            IMessageContract client = null;
-            client = myChannelFactory.CreateChannel();
-            return client;
-        }
+      IMessageContract client = null;
+      client = myChannelFactory.CreateChannel();
+      return client;
+    }
 
-    }
+  }
 }
Index: branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageService.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageService.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Implementation/WcfMessageService.cs	(revision 13553)
@@ -9,5 +9,5 @@
 namespace DistributedGA.Core.Implementation {
   public class WcfMessageService : IMessageService {
-    public event EventHandler<MessageRecieveEventArgs> OnPopulationRecieved;
+    public event EventHandler<MessageRecieveEventArgs> OnDataRecieved;
 
     private static ManualResetEvent _ResetEvent = new ManualResetEvent(false);
@@ -55,6 +55,6 @@
 
     private void OnMessageRecieved(object sender, MessageRecieveEventArgs e) {
-      if (OnPopulationRecieved != null) {
-        OnPopulationRecieved(this, e);
+      if (OnDataRecieved != null) {
+        OnDataRecieved(this, e);
       }
     }
Index: branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageContract.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageContract.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageContract.cs	(revision 13553)
@@ -7,5 +7,5 @@
   public interface IMessageContract {
     [OperationContract]
-    void SendPopulation(PeerInfo sender, SolutionInfo[] population);
+    void SendData(PeerInfo sender, SolutionInfo[] data);
 
     event EventHandler<MessageRecieveEventArgs> MessageRecieved;
Index: branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageHandler.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageHandler.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageHandler.cs	(revision 13553)
@@ -6,7 +6,7 @@
     void Init(); //Registers at contract-server
 
-    void PublishMigrationInfo(SolutionInfo[] population);
+    void PublishDataToNetwork(SolutionInfo[] data);
 
-    SolutionInfo[] GetMigrationInfo();
+    SolutionInfo[] GetDataFromNetwork();
 
     PeerInfo GetPeerInfo();
Index: branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageSender.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageSender.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageSender.cs	(revision 13553)
@@ -1,16 +1,9 @@
 ﻿using DistributedGA.Core.Domain;
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using System.Threading.Tasks;
 
-namespace DistributedGA.Core.Interface
-{
-    public interface IMessageSender
-    {
-        void Init(PeerInfo source);
+namespace DistributedGA.Core.Interface {
+  public interface IMessageSender {
+    void Init(PeerInfo source);
 
-        void SendPopulation(PeerInfo destination, SolutionInfo[] population);
-    }
+    void SendData(PeerInfo destination, SolutionInfo[] data);
+  }
 }
Index: branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageService.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageService.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Core/Interface/IMessageService.cs	(revision 13553)
@@ -13,5 +13,5 @@
     void Dispose();
 
-    event EventHandler<MessageRecieveEventArgs> OnPopulationRecieved;
+    event EventHandler<MessageRecieveEventArgs> OnDataRecieved;
   }
 }
Index: branches/thasling/DistributedGA/DistributedGA.Test/Form1.cs
===================================================================
--- branches/thasling/DistributedGA/DistributedGA.Test/Form1.cs	(revision 13548)
+++ branches/thasling/DistributedGA/DistributedGA.Test/Form1.cs	(revision 13553)
@@ -21,5 +21,5 @@
       IMessageSender c = new WcfMessageSender();
       c.Init(null);
-      c.SendPopulation(null, null);
+      c.SendData(null, null);
     }
 
@@ -36,16 +36,16 @@
       h5.Init();
       var pop1 = CreatePopulation();
-      h1.PublishMigrationInfo(pop1);
-      h1.PublishMigrationInfo(pop1);
-      var res1 = h1.GetMigrationInfo();
-      var res2 = h2.GetMigrationInfo();
-      h1.PublishMigrationInfo(pop1);
-      h1.PublishMigrationInfo(pop1);
-      var res3 = h1.GetMigrationInfo();
-      var res4 = h2.GetMigrationInfo();
-      h1.PublishMigrationInfo(pop1);
-      h1.PublishMigrationInfo(pop1);
-      var res5 = h1.GetMigrationInfo();
-      var res6 = h2.GetMigrationInfo();
+      h1.PublishDataToNetwork(pop1);
+      h1.PublishDataToNetwork(pop1);
+      var res1 = h1.GetDataFromNetwork();
+      var res2 = h2.GetDataFromNetwork();
+      h1.PublishDataToNetwork(pop1);
+      h1.PublishDataToNetwork(pop1);
+      var res3 = h1.GetDataFromNetwork();
+      var res4 = h2.GetDataFromNetwork();
+      h1.PublishDataToNetwork(pop1);
+      h1.PublishDataToNetwork(pop1);
+      var res5 = h1.GetDataFromNetwork();
+      var res6 = h2.GetDataFromNetwork();
       int i = 0;
     }