Index: /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 13566)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/HeuristicLab.Optimizer-3.3.csproj	(revision 13567)
@@ -224,5 +224,7 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="app.config" />
+    <None Include="app.config">
+      <SubType>Designer</SubType>
+    </None>
     <EmbeddedResource Include="Documents\FirstSteps.rtf" />
     <None Include="HeuristicLab.snk" />
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/Plugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/Plugin.cs.frame	(revision 13566)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/Plugin.cs.frame	(revision 13567)
@@ -60,5 +60,23 @@
       }
 
-      if (mainForm != null) {
+      if (mainForm != null) {      
+        mainForm.Location = Settings.Default.MainFormLocation;
+        mainForm.Size = Settings.Default.MainFormSize;
+        mainForm.Load += (sender, eventArgs) => {
+          mainForm.WindowState = Settings.Default.MainFormWindowState;
+        };
+
+        mainForm.FormClosing += (sender, eventArgs) => {
+          Settings.Default.MainFormWindowState = mainForm.WindowState;
+          if (mainForm.WindowState != FormWindowState.Normal) {
+            Settings.Default.MainFormLocation = mainForm.RestoreBounds.Location;
+            Settings.Default.MainFormSize = mainForm.RestoreBounds.Size;
+          } else if (mainForm.WindowState == FormWindowState.Normal) {
+            Settings.Default.MainFormLocation = mainForm.Location;
+            Settings.Default.MainFormSize = mainForm.Size;
+          }
+        };
+
+
         ClientInformation.InitializeAsync();
         UserInformation.InitializeAsync();
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs	(revision 13566)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.Designer.cs	(revision 13567)
@@ -2,5 +2,5 @@
 // <auto-generated>
 //     This code was generated by a tool.
-//     Runtime Version:4.0.30319.34014
+//     Runtime Version:4.0.30319.34209
 //
 //     Changes to this file may cause incorrect behavior and will be lost if
@@ -107,4 +107,40 @@
             }
         }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("0, 0")]
+        public global::System.Drawing.Point MainFormLocation {
+            get {
+                return ((global::System.Drawing.Point)(this["MainFormLocation"]));
+            }
+            set {
+                this["MainFormLocation"] = value;
+            }
+        }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("0, 0")]
+        public global::System.Drawing.Size MainFormSize {
+            get {
+                return ((global::System.Drawing.Size)(this["MainFormSize"]));
+            }
+            set {
+                this["MainFormSize"] = value;
+            }
+        }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("Normal")]
+        public global::System.Windows.Forms.FormWindowState MainFormWindowState {
+            get {
+                return ((global::System.Windows.Forms.FormWindowState)(this["MainFormWindowState"]));
+            }
+            set {
+                this["MainFormWindowState"] = value;
+            }
+        }
     }
 }
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings	(revision 13566)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/Properties/Settings.settings	(revision 13567)
@@ -24,4 +24,13 @@
       <Value Profile="(Default)">DockingMainForm</Value>
     </Setting>
+    <Setting Name="MainFormLocation" Type="System.Drawing.Point" Scope="User">
+      <Value Profile="(Default)">0, 0</Value>
+    </Setting>
+    <Setting Name="MainFormSize" Type="System.Drawing.Size" Scope="User">
+      <Value Profile="(Default)">0, 0</Value>
+    </Setting>
+    <Setting Name="MainFormWindowState" Type="System.Windows.Forms.FormWindowState" Scope="User">
+      <Value Profile="(Default)">Normal</Value>
+    </Setting>
   </Settings>
 </SettingsFile>
Index: /trunk/sources/HeuristicLab.Optimizer/3.3/app.config
===================================================================
--- /trunk/sources/HeuristicLab.Optimizer/3.3/app.config	(revision 13566)
+++ /trunk/sources/HeuristicLab.Optimizer/3.3/app.config	(revision 13567)
@@ -29,4 +29,13 @@
                 <value>DockingMainForm</value>
             </setting>
+            <setting name="MainFormLocation" serializeAs="String">
+                <value>0, 0</value>
+            </setting>
+            <setting name="MainFormSize" serializeAs="String">
+                <value>0, 0</value>
+            </setting>
+            <setting name="MainFormWindowState" serializeAs="String">
+                <value>Normal</value>
+            </setting>
         </HeuristicLab.Optimizer.Properties.Settings>
     </userSettings>